/**
 * @author Leinarion for www.phileasson-projekt.de
 * @file calculatorTest.java
 * 
 */

import org.junit.Before;
import org.junit.Test;


public class calculatorTest  {

	private int[] rs;
	private int noTimes;
	private int noFaces;
	private int noDice;
	private int mod;
	private DSAKalteMain main;
	
	@Before
	public void init(){
		main = new DSAKalteMain();
		rs = new int[]{0,1,11,12,13};
		noTimes = 1;
		noFaces = 6;
		noDice = 2;
		mod = 0;
	}
	
	@Test
	public void testMaxRs(){
		noTimes = 1000;
		assert(main.calculate(rs, noTimes, noDice, noFaces, mod)[3] == 0);
		assert(main.calculate(rs, noTimes, noDice, noFaces, mod)[4] == 0);
	}
	@Test
	public void testMinRS(){
		noTimes = 10000;
		double result = ( (double) main.calculate(rs, noTimes, noDice, noFaces, mod)[0])/(double) noTimes;
		System.out.println(result);
		assert (Math.abs(result-7)< 0.05);
	}
	@Test 
	public void testExtremRolls(){
		noTimes = 1;
		boolean twelve = false;
		boolean two = false;
		for(int i =0; i <10000; i++){
			if(main.calculate(rs, noTimes, noDice, noFaces, mod)[0] == 12);
				twelve = true;
			if(main.calculate(rs, noTimes, noDice, noFaces, mod)[0] == 2);
				two = true;
			assert(main.calculate(rs, noTimes, noDice, noFaces, mod)[0] <= 12);
			assert(main.calculate(rs, noTimes, noDice, noFaces, mod)[0] > 1);	
		}
		assert twelve;
		assert two;
	}
	
}
